package com.eactive.eai.batch.job.jobItem.lgcns;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.CommonKeys;
import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_LGCNS_0610 extends DefaultTelegram implements TelegramService
{

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties jobInfo;
    /**
     * 생성자
     */
    public SEND_LGCNS_0610() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //트랜잭션코드 -- 사용하지 않음
            compileField(1, "", this.al_FieldProps[1]);

            //업무구분코드 - “CMS”
            compileField(2, "CMS", this.al_FieldProps[2]);

            //기관코드 “71”
            compileField(3, "71", this.al_FieldProps[3]);

            //전문종별코드. 전문의 기능을 나타냄.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);

            //거래구분코드 S/R :  서버송신 : S 서버수신: R
            String procType = batchDoc.getBatchMsg().getHeader().getProcessType();
            if ( procType.equalsIgnoreCase(CommonKeys.PROCESS_REQUEST_SEND)) {
                compileField(5, "R", this.al_FieldProps[5]);
            }else{
                compileField(5, "S", this.al_FieldProps[5]);
            }

            //송수신 FLAG B/C    B:Bank, C:Center
            compileField(6, "B", this.al_FieldProps[6]);

            //화일명
            if ( "001|004".indexOf(this.getFldOpCode())> -1 ){
                compileField(7, "", this.al_FieldProps[7]);
            } else {
                compileField(7, batchDoc.getBatchMsg().getHeader().getFileName() , this.al_FieldProps[7]);
            }

            //응답코드
            compileField(8, this.getResolveResponseCode(), this.al_FieldProps[8]);

            //전문 전송 일시 (MMddhhmmss)
            compileField(9, TelegramKeys.getMMddHHmmss(), this.al_FieldProps[9]);

            //업무관리정보. CMS 업무 관리를 위한 코드.
            //001-업무개시, 002-화일 송수신 완료(송신할 화일 존재), 003-화일 송수신 완료(송신할 화일 없음), 004-업무종료
            compileField(10, this.getFldOpCode(), this.al_FieldProps[10]);

            //자기계정  - 사용하지 않음
            compileField(11, "", this.al_FieldProps[11]);

            //송신자명 (CMS시스템의 책임자 ID
            compileField(12, batchDoc.getBatchMsg().getHeader().getUserID(), this.al_FieldProps[12]);

            //송신자 암호 (정당한 송신자 확인을 위한 쌍방간 합의된 암호
            compileField(13, batchDoc.getBatchMsg().getHeader().getUserPassword(), this.al_FieldProps[13]);

            //상대계정  - 사용하지 않음
            compileField(14, "", this.al_FieldProps[14]);

            //상대ID
            compileField(15, jobInfo.getProperty(TelegramKeys.MLINK_DOC_RECV_ID), this.al_FieldProps[15]);
            
            //시작일자
            compileField(16, TelegramKeys.getYYYYMMDD() + "0000", this.al_FieldProps[9]);

            //종료일자
            compileField(17, TelegramKeys.getYYYYMMDD() + "2359", this.al_FieldProps[9]);

            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            jobInfo = getJobInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            if (this.getFldOpCode().equals("001"))  return true;

            //이하 응답코드가 '업무개시'가 아닌 경우에만 처리
            //수신 파일 관련 처리
            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();
            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }
            String fileName = fileDir + fileNm;

            File rcvRealFile = new File( fileName );
            File rcvArchFile = new File( StringUtil.realToArchDir(fileName) );
            File rcvRootFile = new File( StringUtil.realToRootDir(fileName) );

            if ((fileNm != null) && (!fileNm.trim().equals(""))&& (rcvRealFile.exists())) {

                //DB로그에 남길 파일 헤더,트레일러 내용 설정
                super.setFileHeaderAndTrailer(rcvRealFile);

                //DB로그에 남길 변경 파일명 설정 (파일명 변경 안함)
                batchDoc.getBatchMsg().getHeader().setRenamedFileName(fileName);
                //수신 Real 디렉토리 -> Arch 디렉토리로 파일 이동 (파일명 변경 안한고 동일 파일명 존재시 Overwrite)
                logger.info("{} >>>>> 수신 파일을 수신 Real 디렉토리 -> 수신 Arch 디렉토리로 이동.....", logHeader);
                boolean isSuccessMoveFile = rcvRealFile.renameTo(rcvArchFile);
                if (!isSuccessMoveFile) {
                    String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI030", new String[] {rcvRealFile.getAbsolutePath(), rcvArchFile.getAbsolutePath()});
                    batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);    //수신 파일을 수신 Real 디렉토리에서 수신 Arch 디렉로 이동시 오류가 발생하였습니다. [Real Path: {1}] [Arch Path: {2}]
                    super.setResolveResponseCode(TelegramKeys.RPS_HDB_RET_CODE_OTHER_ERROR);
                    //수신 파일 End DB로그
                    LogUtil.setLogFileEnd(batchDoc);
                    return true;  //다음단계 수행시 응답코드를 기준으로 에러전문을 송신하기위해 true 설정함
                }

                logger.info("{} >>>>> 수신 파일과 동일 파일명의 0 Byte 파일을 Root 디렉토리에 생성......(HOST에 자동 송신하도록 수신 File Event 발생)", logHeader);
                try {
                    isSuccessMoveFile = rcvRootFile.createNewFile();
                } catch (Exception e) { } // 실패인 경우 무시하고 로깅만 하도록....

                if (!isSuccessMoveFile) {
                    String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI031", new String[] {rcvRootFile.getAbsolutePath()});
                    batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);    //수신 Root 디렉토리에 0 Byte 파일을 생성할 수 없습니다. [Path: {1}]
                }

                //수신 파일 End DB로그
                LogUtil.setLogFileEnd(batchDoc);
           }

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(10);
    }
}